/*
 * @license
 * chartjs-plugin-rough
 * https://github.com/nagix/chartjs-plugin-rough/
 * Version: 0.1.0
 *
 * Copyright 2019 Akihiko Kusanagi
 * Released under the MIT license
 * https://github.com/nagix/chartjs-plugin-rough/blob/master/LICENSE.md
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t(require("chart.js"),require("roughjs")):"function"==typeof define&&define.amd?define(["chart.js","roughjs"],t):e.ChartRough=t(e.Chart,e.rough)}(this,function(g,D){"use strict";g=g&&g.hasOwnProperty("default")?g.default:g,D=D&&D.hasOwnProperty("default")?D.default:D;var e=g.helpers;g.layouts=g.layouts||g.layoutService,e.canvas=e.canvas||{},e.canvas._isPointInArea=e.canvas._isPointInArea||function(e,t){return e.x>t.left-1e-6&&e.x<t.right+1e-6&&e.y>t.top-1e-6&&e.y<t.bottom+1e-6};var t=Math.PI,C=t/180,S=t/4,_=2*t/3,W={roughKeys:["roughness","bowing","fillStyle","fillWeight","hachureAngle","hachureGap","curveStepCount","simplification"],drawPoint:function(e,t,o,r,a,n,l,i){var d,s,u,h,c,g,p,b,f,v,m=this.getFillOptions(i),y=this.getStrokeOptions(i),x=(n||0)*C;if(!t||"object"!=typeof t||"[object HTMLImageElement]"!==(d=t.toString())&&"[object HTMLCanvasElement]"!==d){if(!(isNaN(o)||o<=0))switch(t){default:l.circle(r,a,2*o,m),l.circle(r,a,2*o,y);break;case"triangle":(b=[]).push([r+Math.sin(x)*o,a-Math.cos(x)*o]),x+=_,b.push([r+Math.sin(x)*o,a-Math.cos(x)*o]),x+=_,b.push([r+Math.sin(x)*o,a-Math.cos(x)*o]),l.polygon(b,m),l.polygon(b,y);break;case"rectRounded":p=.516*o,h=Math.cos(x)*p,c=Math.sin(x)*p,x+=S,g=o-p,f="M"+(r-(s=Math.cos(x)*g)-h)+" "+(a-(u=Math.sin(x)*g)-c)+(v="A"+p+" "+p+" 0 0 1 ")+(r-s+c)+" "+(a-u-h)+"L"+(r+u+c)+" "+(a-s-h)+v+(r+u+h)+" "+(a-s+c)+"L"+(r+s+h)+" "+(a+u+c)+v+(r+s-c)+" "+(a+u+h)+"L"+(r-u-c)+" "+(a+s+h)+v+(r-u-h)+" "+(a+s-c)+"Z",l.path(f,m),l.path(f,y);break;case"rect":if(!n){g=Math.SQRT1_2*o,l.rectangle(r-g,a-g,2*g,2*g,m),l.rectangle(r-g,a-g,2*g,2*g,y);break}x+=S;case"rectRot":b=[[r-(s=Math.cos(x)*o),a-(u=Math.sin(x)*o)],[r+u,a-s],[r+s,a+u],[r-u,a+s]],l.polygon(b,m),l.polygon(b,y);break;case"crossRot":x+=S;case"cross":s=Math.cos(x)*o,u=Math.sin(x)*o,l.line(r-s,a-u,r+s,a+u,y),l.line(r+u,a-s,r-u,a+s,y);break;case"star":s=Math.cos(x)*o,u=Math.sin(x)*o,l.line(r-s,a-u,r+s,a+u,y),l.line(r+u,a-s,r-u,a+s,y),x+=S,s=Math.cos(x)*o,u=Math.sin(x)*o,l.line(r-s,a-u,r+s,a+u,y),l.line(r+u,a-s,r-u,a+s,y);break;case"line":s=Math.cos(x)*o,u=Math.sin(x)*o,l.line(r-s,a-u,r+s,a+u,y);break;case"dash":l.line(r,a,r+Math.cos(x)*o,a+Math.sin(x)*o,y)}}else e.drawImage(t,r-t.width/2,a-t.height/2,t.width,t.height)},lineTo:function(e,t,o){var r,a=t.steppedLine;return a?("middle"===a?"L"+(r=(e.x+t.x)/2)+" "+(o?t.y:e.y)+"L"+r+" "+(o?e.y:t.y):"after"===a&&!o||"after"!==a&&o?"L"+e.x+" "+t.y:"L"+t.x+" "+e.y)+"L"+t.x+" "+t.y:t.tension?"C "+(o?e.controlPointPreviousX:e.controlPointNextX)+" "+(o?e.controlPointPreviousY:e.controlPointNextY)+","+(o?t.controlPointNextX:t.controlPointPreviousX)+" "+(o?t.controlPointNextY:t.controlPointPreviousY)+","+t.x+" "+t.y:"L"+t.x+" "+t.y},resolve:function(e,t){var o=e.rough;return!1===o?null:(!0===o&&(o={}),g.helpers.merge({},[t,o]))},getFillOptions:function(t){var o={stroke:"transparent",fill:t.backgroundColor};return this.roughKeys.forEach(function(e){void 0!==t[e]&&(o[e]=t[e])}),o},getStrokeOptions:function(t){var o={stroke:t.borderColor,strokeWidth:t.borderWidth};return["roughness","bowing","curveStepCount","simplification"].forEach(function(e){void 0!==t[e]&&(o[e]=t[e])}),o}},o=g.elements.Arc.extend({draw:function(){var e=this._view,t=e.x,o=e.y,r=e.outerRadius,a=e.innerRadius,n=e.startAngle,l=e.endAngle,i=Math.cos(n),d=Math.sin(n),s=Math.cos(l),u=Math.sin(l),h=l-n>Math.PI?1:0,c=D.canvas(this._chart.canvas),g="M"+(t+r*i)+" "+(o+r*d)+"A"+r+" "+r+" 0 "+h+" 1 "+(t+r*s)+" "+(o+r*u)+"L"+(t+a*s)+" "+(o+a*u)+"A"+a+" "+a+" 0 "+h+" 0 "+(t+a*i)+" "+(o+a*d)+"Z";c.path(g,W.getFillOptions(e)),e.borderWidth&&c.path(g,W.getStrokeOptions(e))}}),r=g.elements.Line.extend({draw:function(){var e,t,o,r,a=this._view,n=a.spanGaps,l=this._children.slice(),i=-1,d=D.canvas(this._chart.canvas),s="";for(this._loop&&l.length&&l.push(l[0]),i=-1,e=0;e<l.length;++e)t=l[e],o=g.helpers.previousItem(l,e),r=t._view,0===e?r.skip||(s+="M"+r.x+" "+r.y,i=e):(o=-1===i?o:l[i],r.skip||(s+=i!==e-1&&!n||-1===i?"M"+r.x+" "+r.y:W.lineTo(o._view,t._view),i=e));d.path(s,W.getStrokeOptions(a))}}),a=g.elements.Point.extend({draw:function(e){var t=this._view,o=this._chart,r=o.ctx,a=D.canvas(o.canvas);t.skip||(void 0===e||g.helpers.canvas._isPointInArea(t,e))&&W.drawPoint(r,t.pointStyle,t.radius,t.x,t.y,t.rotation,a,t)}}),n=g.elements.Rectangle.extend({draw:function(){var e,t,o,r,a,n,l,i=this._view,d=i.borderWidth,s=D.canvas(this._chart.canvas);if(l=i.horizontal?(e=i.base,t=i.x,o=i.y-i.height/2,r=i.y+i.height/2,a=e<t?1:-1,n=1,i.borderSkipped||"left"):(e=i.x-i.width/2,t=i.x+i.width/2,a=1,n=(o=i.y)<(r=i.base)?1:-1,i.borderSkipped||"bottom"),d){var u=Math.min(Math.abs(e-t),Math.abs(o-r)),h=(d=u<d?u:d)/2,c=e+("left"!==l?h*a:0),g=t+("right"!==l?-h*a:0),p=o+("top"!==l?h*n:0),b=r+("bottom"!==l?-h*n:0);c!==g&&(o=p,r=b),p!==b&&(e=c,t=g)}var f=[[e,r],[e,o],[t,o],[t,r]],v=["bottom","left","top","right"].indexOf(l,0);function m(e){return f[(v+e)%4]}if(-1===v&&(v=0),s.rectangle(f[1][0],f[1][1],f[3][0]-f[1][0],f[3][1]-f[1][1],W.getFillOptions(i)),d)for(var y=m(0),x=1;x<4;x++){var C=m(x);s.line(y[0],y[1],C[0],C[1],W.getStrokeOptions(i)),y=C}}}),u=g.helpers,h=u.options.resolve,l=g.controllers.bar.extend({dataElementType:n,updateElement:function(e,t,o){var r=this,a=r.chart,n=r.getMeta(),l=r.getDataset(),i=e.custom||{},d=a.options,s=d.elements.rectangle;e._xScale=r.getScaleForId(n.xAxisID),e._yScale=r.getScaleForId(n.yAxisID),e._datasetIndex=r.index,e._index=t,e._model=u.merge({datasetLabel:l.label,label:a.data.labels[t],borderSkipped:u.valueOrDefault(i.borderSkipped,s.borderSkipped),backgroundColor:h([i.backgroundColor,l.backgroundColor,s.backgroundColor],void 0,t),borderColor:h([i.borderColor,l.borderColor,s.borderColor],void 0,t),borderWidth:h([i.borderWidth,l.borderWidth,s.borderWidth],void 0,t)},W.resolve(l,d.plugins.rough)),r.updateElementGeometry(e,t,o),e.pivot()}}),i=g.controllers.bubble.extend({dataElementType:a,updateElement:function(e,t,o){var r=this,a=r.getMeta(),n=e.custom||{},l=r.getScaleForId(a.xAxisID),i=r.getScaleForId(a.yAxisID),d=r._resolveElementOptions(e,t),s=r.getDataset().data[t],u=r.index,h=o?l.getPixelForDecimal(.5):l.getPixelForValue("object"==typeof s?s:NaN,t,u),c=o?i.getBasePixel():i.getPixelForValue(s,t,u);e._xScale=l,e._yScale=i,e._options=d,e._datasetIndex=u,e._index=t,e._model=g.helpers.merge({backgroundColor:d.backgroundColor,borderColor:d.borderColor,borderWidth:d.borderWidth,hitRadius:d.hitRadius,pointStyle:d.pointStyle,rotation:d.rotation,radius:o?0:d.radius,skip:n.skip||isNaN(h)||isNaN(c),x:h,y:c},W.resolve(r.getDataset(),r.chart.options.plugins.rough)),e.pivot()}}),d=g.defaults,y=g.helpers,x=y.options.resolve;d.doughnut.legend.labels.generateLabels=d.pie.legend.labels.generateLabels=function(d){var s=d.data;return s.labels.length&&s.datasets.length?s.labels.map(function(e,t){var o=d.getDatasetMeta(0),r=s.datasets[0],a=o.data[t],n=a&&a.custom||{},l=d.options,i=l.elements.arc;return{text:e,fillStyle:x([n.backgroundColor,r.backgroundColor,i.backgroundColor],void 0,t),strokeStyle:x([n.borderColor,r.borderColor,i.borderColor],void 0,t),lineWidth:x([n.borderWidth,r.borderWidth,i.borderWidth],void 0,t),hidden:isNaN(r.data[t])||o.data[t].hidden,rough:W.resolve(r,l.plugins.rough),index:t}}):[]};var s=g.controllers.doughnut.extend({dataElementType:o,updateElement:function(e,t,o){var r=this,a=r.chart,n=a.chartArea,l=a.options,i=l.animation,d=(n.left+n.right)/2,s=(n.top+n.bottom)/2,u=l.rotation,h=l.rotation,c=r.getDataset(),g=o&&i.animateRotate?0:e.hidden?0:r.calculateCircumference(c.data[t])*(l.circumference/(2*Math.PI)),p=o&&i.animateScale?0:r.innerRadius,b=o&&i.animateScale?0:r.outerRadius;y.extend(e,{_datasetIndex:r.index,_index:t,_model:{x:d+a.offsetX,y:s+a.offsetY,startAngle:u,endAngle:h,circumference:g,outerRadius:b,innerRadius:p,label:y.valueAtIndexOrDefault(c.label,t,a.data.labels[t])}});var f=e._model,v=e.custom||{},m=l.elements.arc;f.backgroundColor=x([v.backgroundColor,c.backgroundColor,m.backgroundColor],void 0,t),f.borderColor=x([v.borderColor,c.borderColor,m.borderColor],void 0,t),f.borderWidth=x([v.borderWidth,c.borderWidth,m.borderWidth],void 0,t),y.merge(f,W.resolve(c,l.plugins.rough)),o&&i.animateRotate||(f.startAngle=0===t?l.rotation:r.getMeta().data[t-1]._model.endAngle,f.endAngle=f.startAngle+f.circumference),e.pivot()}}),c=l.extend({getValueScaleId:function(){return this.getMeta().xAxisID},getIndexScaleId:function(){return this.getMeta().yAxisID}}),p=g.helpers,b=p.valueOrDefault,f=p.options.resolve,v=g.controllers.line;var m=v.extend({datasetElementType:r,dataElementType:a,update:function(e){var t,o,r,a,n=this,l=n.getMeta(),i=l.dataset,d=l.data||[],s=n.chart.options,u=s.elements.line,h=n.getScaleForId(l.yAxisID),c=n.getDataset(),g=(a=s,b(c.showLine,a.showLines));for(g&&(r=i.custom||{},void 0!==c.tension&&void 0===c.lineTension&&(c.lineTension=c.tension),i._scale=h,i._datasetIndex=n.index,i._children=d,i._model=p.merge({spanGaps:b(c.spanGaps,s.spanGaps),tension:f([r.tension,c.lineTension,u.tension]),backgroundColor:f([r.backgroundColor,c.backgroundColor,u.backgroundColor]),borderWidth:f([r.borderWidth,c.borderWidth,u.borderWidth]),borderColor:f([r.borderColor,c.borderColor,u.borderColor]),borderCapStyle:f([r.borderCapStyle,c.borderCapStyle,u.borderCapStyle]),borderDash:f([r.borderDash,c.borderDash,u.borderDash]),borderDashOffset:f([r.borderDashOffset,c.borderDashOffset,u.borderDashOffset]),borderJoinStyle:f([r.borderJoinStyle,c.borderJoinStyle,u.borderJoinStyle]),fill:f([r.fill,c.fill,u.fill]),steppedLine:f([r.steppedLine,c.steppedLine,u.stepped]),cubicInterpolationMode:f([r.cubicInterpolationMode,c.cubicInterpolationMode,u.cubicInterpolationMode])},W.resolve(c,s.plugins.rough)),i.pivot()),t=0,o=d.length;t<o;++t)n.updateElement(d[t],t,e);for(g&&0!==i._model.tension&&n.updateBezierControlPoints(),t=0,o=d.length;t<o;++t)d[t].pivot()},updateElement:function(e){v.prototype.updateElement.apply(this,arguments),p.merge(e._model,W.resolve(this.getDataset(),this.chart.options.plugins.rough))}}),k=g.helpers,M=k.options.resolve;g.defaults.polarArea.legend.labels.generateLabels=function(i){var d=i.data;return d.labels.length&&d.datasets.length?d.labels.map(function(e,t){var o=i.getDatasetMeta(0),r=d.datasets[0],a=o.data[t].custom||{},n=i.options,l=n.elements.arc;return{text:e,fillStyle:M([a.backgroundColor,r.backgroundColor,l.backgroundColor],void 0,t),strokeStyle:M([a.borderColor,r.borderColor,l.borderColor],void 0,t),lineWidth:M([a.borderWidth,r.borderWidth,l.borderWidth],void 0,t),hidden:isNaN(r.data[t])||o.data[t].hidden,rough:W.resolve(r,n.plugins.rough),index:t}}):[]};var I=g.controllers.polarArea.extend({dataElementType:o,updateElement:function(e,t,o){var r,a,n=this,l=n.chart,i=n.getDataset(),d=l.options,s=d.animation,u=l.scale,h=l.data.labels,c=u.xCenter,g=u.yCenter,p=d.startAngle,b=e.hidden?0:u.getDistanceFromCenterForValue(i.data[t]);if(n.calculateCircumference){for(var f=n.calculateCircumference(i.data[t]),v=0,m=n.getMeta(),y=0;y<t;++y)isNaN(i.data[y])||m.data[y].hidden||++v;a=(r=p+f*v)+(e.hidden?0:f)}else a=(r=n._starts[t])+(e.hidden?0:n._angles[t]);var x=s.animateScale?0:u.getDistanceFromCenterForValue(i.data[t]);k.extend(e,{_datasetIndex:n.index,_index:t,_scale:u,_model:{x:c,y:g,innerRadius:0,outerRadius:o?x:b,startAngle:o&&s.animateRotate?p:r,endAngle:o&&s.animateRotate?p:a,label:k.valueAtIndexOrDefault(h,t,h[t])}});var C=d.elements.arc,S=e.custom||{},_=e._model;_.backgroundColor=M([S.backgroundColor,i.backgroundColor,C.backgroundColor],void 0,t),_.borderColor=M([S.borderColor,i.borderColor,C.borderColor],void 0,t),_.borderWidth=M([S.borderWidth,i.borderWidth,C.borderWidth],void 0,t),k.merge(_,W.resolve(i,d.plugins.rough)),e.pivot()}}),A=g.helpers,P=A.options.resolve,w=g.controllers.radar,O=w.extend({datasetElementType:r,dataElementType:a,update:function(o){var r=this,e=r.getMeta(),t=e.dataset,a=e.data,n=t.custom||{},l=r.getDataset(),i=r.chart.options,d=i.elements.line,s=r.chart.scale;void 0!==l.tension&&void 0===l.lineTension&&(l.lineTension=l.tension),A.extend(e.dataset,{_datasetIndex:r.index,_scale:s,_children:a,_loop:!0,_model:A.merge({tension:P([n.tension,l.lineTension,d.tension]),backgroundColor:P([n.backgroundColor,l.backgroundColor,d.backgroundColor]),borderWidth:P([n.borderWidth,l.borderWidth,d.borderWidth]),borderColor:P([n.borderColor,l.borderColor,d.borderColor]),fill:P([n.fill,l.fill,d.fill]),borderCapStyle:P([n.borderCapStyle,l.borderCapStyle,d.borderCapStyle]),borderDash:P([n.borderDash,l.borderDash,d.borderDash]),borderDashOffset:P([n.borderDashOffset,l.borderDashOffset,d.borderDashOffset]),borderJoinStyle:P([n.borderJoinStyle,l.borderJoinStyle,d.borderJoinStyle])},W.resolve(l,i.plugins.rough))}),e.dataset.pivot(),A.each(a,function(e,t){r.updateElement(e,t,o)},r),r.updateBezierControlPoints()},updateElement:function(e){w.prototype.updateElement.apply(this,arguments),A.merge(e._model,W.resolve(this.getDataset(),this.chart.options.plugins.rough))}}),R=g.helpers,L=g.plugins.getAll().filter(function(e){return"filler"===e.id})[0];function T(e){return e&&!e.skip}function E(e,t,o,r){var a,n;if(o&&r){for(a="M"+e[0].x+" "+e[0].y,n=1;n<o;++n)a+=W.lineTo(e[n-1],e[n]);for(a+="L"+t[r-1].x+" "+t[r-1].y,n=r-1;0<n;--n)a+=W.lineTo(t[n],t[n-1],!0);return a}}var F=R.merge({},[L,{beforeDatasetDraw:function(e,t){var o=t.meta.$filler;if(o){var r=e.ctx,a=o.el,n=a._view,l=a._children||[],i=o.mapper,d=n.backgroundColor||g.defaults.global.defaultColor;i&&d&&l.length&&(R.canvas.clipArea(r,e.chartArea),function(e,t,o,r,a,n){var l,i,d,s,u,h,c,g=t.length,p=r.spanGaps,b=[],f=[],v=0,m=0,y=D.canvas(e.canvas),x="";for(l=0,i=g+!!n;l<i;++l)u=o(s=t[d=l%g]._view,d,r),h=T(s),c=T(u),h&&c?(v=b.push(s),m=f.push(u)):v&&m&&(p?(h&&b.push(s),c&&f.push(u)):(x+=E(b,f,v,m),v=m=0,b=[],f=[]));x+=E(b,f,v,m),y.path(x,W.getFillOptions(r))}(e,l,i,n,0,a._loop),R.canvas.unclipArea(r))}}}]),N=g.defaults,B=g.helpers,J=g.layouts,j=B.isArray,z=B.valueOrDefault;N.global.legend.labels.generateLabels=function(o){var e=o.data;return j(e.datasets)?e.datasets.map(function(e,t){return{text:e.label,fillStyle:B.valueAtIndexOrDefault(e.backgroundColor,0),hidden:!o.isDatasetVisible(t),lineCap:e.borderCapStyle,lineDash:e.borderDash,lineDashOffset:e.borderDashOffset,lineJoin:e.borderJoinStyle,lineWidth:e.borderWidth,strokeStyle:e.borderColor,pointStyle:e.pointStyle,rough:W.resolve(e,o.options.plugins.rough),datasetIndex:t}},this):[]};var G=g.Legend.extend({draw:function(){var e,t,h=this,c=h.options,g=c.labels,p=N.global,b=p.elements.line,f=h.width,v=h.lineWidths,m=D.canvas(this.chart.canvas);if(c.display){var y,x=h.ctx,o=z(g.fontColor,p.defaultFontColor),C=z(g.fontSize,p.defaultFontSize),r=z(g.fontStyle,p.defaultFontStyle),a=z(g.fontFamily,p.defaultFontFamily),n=B.fontString(C,r,a);x.textAlign="left",x.textBaseline="middle",x.lineWidth=.5,x.strokeStyle=o,x.fillStyle=o,x.font=n;var S=(t=C,(e=g).usePointStyle?t*Math.SQRT2:e.boxWidth),_=h.legendHitBoxes,k=h.isHorizontal();y=k?{x:h.left+(f-v[0])/2,y:h.top+g.padding,line:0}:{x:h.left+g.padding,y:h.top+g.padding,line:0};var M=C+g.padding;B.each(h.legendItems,function(e,t){var o,r,a,n,l,i=x.measureText(e.text).width,d=S+C/2+i,s=y.x,u=y.y;k?f<=s+d&&(u=y.y+=M,y.line++,s=y.x=h.left+(f-v[y.line])/2):u+M>h.bottom&&(s=y.x=s+h.columnWidths[y.line]+g.padding,u=y.y=h.top+g.padding,y.line++),function(e,t,o){if(!(isNaN(S)||S<=0)){var r=0===z(o.lineWidth,b.borderWidth),a=B.merge({borderColor:z(o.strokeStyle,p.defaultColor),borderWidth:z(o.lineWidth,b.borderWidth),backgroundColor:z(o.fillStyle,p.defaultColor)},o.rough);if(c.labels&&c.labels.usePointStyle){var n=C*Math.SQRT2/2,l=n/Math.SQRT2,i=e+l,d=t+l;W.drawPoint(x,o.pointStyle,n,i,d,0,m,a)}else m.rectangle(e,t,S,C,W.getFillOptions(a)),r||m.rectangle(e,t,S,C,W.getStrokeOptions(a))}}(s,u,e),_[t].left=s,_[t].top=u,o=e,r=i,n=S+(a=C/2)+s,l=u+a,x.fillText(o.text,n,l),o.hidden&&(x.beginPath(),x.lineWidth=2,x.moveTo(n,l),x.lineTo(n+r,l),x.stroke()),k?y.x+=d+g.padding:y.y+=M})}}});function V(e,t){var o=new G({ctx:e.ctx,options:t,chart:e});J.configure(e,o,t),J.addBox(e,o),e.legend=o}var H={id:"legend",_element:G,beforeInit:function(e){var t=e.options.legend;t&&V(e,t)},beforeUpdate:function(e){var t=e.options.legend,o=e.legend;t?(B.mergeIf(t,N.global.legend),o?(J.configure(e,o,t),o.options=t):V(e,t)):o&&(J.removeBox(e,o),delete e.legend)},afterEvent:function(e,t){var o=e.legend;o&&o.handleEvent(t)}},X=g.controllers,Y=g.plugins;g.defaults.global.plugins.rough={roughness:1,bowing:1,fillStyle:"hachure",fillWeight:.5,hachureAngle:-41,hachureGap:4,curveStepCount:9,simplification:0};var Q={bar:l,bubble:i,doughnut:s,horizontalBar:c,line:m,polarArea:I,pie:s,radar:O,scatter:m},$=Y.descriptors;Y.descriptors=function(e){var t=e._rough;if(t){var o=e.$plugins||e._plugins||(e.$plugins=e._plugins={});if(o.id===this._cacheId)return o.descriptors;var r,a=this._plugins;this._plugins=a.map(function(e){return"filler"===e.id?F:"legend"===e.id?H:e})}return r=$.apply(this,arguments),t&&(this._plugins=a),r};var U={id:"rough",beforeInit:function(e){e._rough={},e.buildOrUpdateControllers=function(){var e;return g.controllers=Q,e=g.prototype.buildOrUpdateControllers.apply(this,arguments),g.controllers=X,e},e.legend&&(g.layouts.removeBox(e,e.legend),delete e.legend),delete e.$plugins,delete e._plugins,Y.descriptors(e)}};return g.helpers.rough=W,g.elements.RoughArc=o,g.elements.RoughLine=r,g.elements.RoughPoint=a,g.elements.RoughRectangle=n,g.controllers.roughBar=l,g.controllers.roughBubble=i,g.controllers.roughDoughnut=g.controllers.roughPie=s,g.controllers.roughHorizontalBar=c,g.controllers.roughLine=g.controllers.roughScatter=m,g.controllers.roughPolarArea=I,g.controllers.roughRadar=O,U});